/*
 * ByteArray_test.cpp
 *
 *  Created on: May 18, 2014
 *      Author: cihanbe
 */
#include "../expression/ByteArray.h"
#include <gtest/gtest.h>
#include <stdio.h>

//class ByteArray_test:public ::testing::Test
//{
//};


TEST(ByteArray, Constructor)
{
	ByteArray m;
	EXPECT_EQ(0,m.Size());
	EXPECT_EQ(NULL, m.Data());
	EXPECT_EQ(NULL, m.Name());
}

TEST(ByteArray, Deconstructor)
{
	ByteArray *m = new ByteArray();
	EXPECT_EQ(0,m->Size());
	EXPECT_EQ(NULL, m->Data());
	EXPECT_EQ(NULL, m->Name());
	delete m;
}

TEST(ByteArray, SetDataFromHexStringAndName)
{
	unsigned char expected[32];
	expected[0] = 0x03;
	expected[1] = 0x03;
	expected[2] = 0x02;
	expected[3] = 0x04;
	expected[4] = 0x03;
	expected[5] = 0x03;
	expected[6] = 0x02;
	expected[7] = 0x04;
	expected[8] = 0x03;
	expected[9] = 0x03;
	expected[10] = 0x02;
	expected[11] = 0x04;
	expected[12] = 0x03;
	expected[13] = 0x03;
	expected[14] = 0x02;
	expected[15] = 0x04;
	expected[16] = 0x03;
	expected[17] = 0x03;
	expected[18] = 0x02;
	expected[19] = 0x04;
	expected[20] = 0x03;
	expected[21] = 0x03;
	expected[22] = 0x02;
	expected[23] = 0x04;
	expected[24] = 0x03;
	expected[25] = 0x03;
	expected[26] = 0x02;
	expected[27] = 0x04;
	expected[28] = 0x03;
	expected[29] = 0x03;
	expected[30] = 0x02;
	expected[31] = 0x04;


	ByteArray m;
	m.SetDataFromHexString("0x0303020403030204030302040303020403030204030302040303020403030204");
	m.SetName("deneme");
	EXPECT_EQ(32,m.Size());
	EXPECT_EQ(0, memcmp(expected, m.Data(), m.Size()));
	EXPECT_EQ(0, memcmp("deneme", m.Name(), strlen(m.Name())));
}


