/*
 * Device.cpp
 *
 *  Created on: Apr 20, 2014
 *      Author: cihan
 */

#include "Device.h"

Device::Device(const char * name)
{
	m_device_name = new char[strlen(name)+1];
	strcpy(m_device_name, name);
	index_of_jobs = 0;
	//memcpy(m_device_name, name, strlen(name)+1);
}

Device::~Device()
{
	for(unsigned int i = 0; i < m_job_list.size(); i++)
	{
		delete[] m_job_list[i];
	}

	delete[] m_device_name;
}

char*
Device::GetDeviceName()
{
	return m_device_name;
}

void
Device::PushJob(const char * job)
{
	char * new_job = new char[strlen(job)+1];
	strcpy(new_job, job);
	//memcpy(new_job, job, strlen(job)+1);
	m_job_list.push_back(new_job);
}

void
Device::ExecuteNextProcess()
{
	ByteArray result;
	m_prs.parse(m_job_list[index_of_jobs],result);

	printf("[%s]=>\n[%s]\nRESULT: ", m_device_name, m_job_list[index_of_jobs]);
	for(unsigned int i = 0; i < result.Size(); i++)
	{
		printf("%02X ",result.Data()[i]);
	}
	printf("\n\n");
	index_of_jobs++;
}

//const char *
//Device::ExecuteNextProcess()
//{
//    ByteArray result;
//    const char * process = m_process_list.front();
//    m_prs.parse(process,result);
//    //TODO:: clear process
//    m_process_list.pop();
//    printf("%s\n%s\nResult: ",m_device_name , process); result.PrintAsHexString(); printf("\n\n");
//    return process;
//}
