/*
 * Device.h
 *
 *  Created on: Apr 20, 2014
 *      Author: cihan
 */

#ifndef DEVICE_H_
#define DEVICE_H_

#include "expression/parser.h"
#include <queue>

class Device {
public:
	Device(const char * name);

	virtual ~Device();

	char* GetDeviceName();
	void PushJob(const char * job);
	void ExecuteNextProcess();
	//const char * ExecuteNextProcess();

private:
	char * m_device_name;
	std::deque<const char*> m_job_list;
	unsigned int index_of_jobs;
	Parser m_prs;
};

#endif /* DEVICE_H_ */
